"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _spin = _interopRequireDefault(require("antd/lib/spin"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TopContent = _interopRequireDefault(require("./mods/TopContent"));

var _PhoneModel = _interopRequireDefault(require("./mods/PhoneModel"));

var _OfferItemColums = _interopRequireDefault(require("./mods/OfferItemColums"));

var _OfferItemRow = _interopRequireDefault(require("./mods/OfferItemRow"));

require("./index.scss");

var CapacityOffer = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(CapacityOffer, _Component);

  function CapacityOffer(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {};
    _this.renderOfferItemColums = _this.renderOfferItemColums.bind((0, _assertThisInitialized2["default"])(_this));
    _this.onRemove = _this.onRemove.bind((0, _assertThisInitialized2["default"])(_this));
    _this.onAdd = _this.onAdd.bind((0, _assertThisInitialized2["default"])(_this));
    _this.renderSelcetList = _this.renderSelcetList.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  var _proto = CapacityOffer.prototype;

  _proto.onAdd = function onAdd(dataSource) {
    var selectList = this.props.selectList;
    selectList.push(dataSource);
    this.props.onChange(selectList, 'add');
  };

  _proto.onRemove = function onRemove(dataSource) {
    var selectList = this.props.selectList;
    var thisIndex = -1;
    selectList.forEach(function (item, index) {
      if (item.skuId === dataSource.skuId) {
        thisIndex = index;
      }
    });
    selectList.splice(thisIndex, 1);
    this.props.onChange(selectList, 'remove');
  };

  _proto.openOfferDetail = function openOfferDetail(item) {
    this.props.openOfferDetail(item);
  };

  _proto.renderOfferItemColums = function renderOfferItemColums() {
    var _this2 = this;

    var _this$props = this.props,
        spinning = _this$props.spinning,
        offerList = _this$props.offerList,
        selectList = _this$props.selectList;

    if (spinning) {
      return _react["default"].createElement(_spin["default"], {
        spinning: spinning
      });
    } else {
      return offerList && offerList.map(function (item, index) {
        var selected = selectList && selectList.some(function (it) {
          return it.skuId === item.skuId;
        });
        return _react["default"].createElement(_OfferItemColums["default"], {
          openOfferDetail: _this2.openOfferDetail.bind(_this2, item),
          onAdd: _this2.onAdd,
          className: "offer_item_wa",
          selected: selected,
          dataSource: item,
          key: index
        });
      });
    }
  };

  _proto.renderSelcetList = function renderSelcetList() {
    var _this3 = this;

    var _this$props$selectLis = this.props.selectList,
        selectList = _this$props$selectLis === void 0 ? [] : _this$props$selectLis;

    if (selectList.length) {
      return selectList.map(function (item, index) {
        return _react["default"].createElement(_OfferItemRow["default"], {
          onRemove: _this3.onRemove,
          dataSource: item,
          key: index
        });
      });
    } else {
      return _react["default"].createElement("div", {
        className: "selcet_empty"
      }, _react["default"].createElement("span", null, "\u60A8\u6682\u65F6\u8FD8\u6CA1\u6709\u6311\u9009\u5546\u54C1\u6B27\uFF01"));
    }
  };

  _proto.render = function render() {
    var selectList = this.props.selectList;
    return _react["default"].createElement("div", {
      className: "capacity_offer"
    }, _react["default"].createElement(_TopContent["default"], this.props), _react["default"].createElement("div", {
      className: "capacity_content"
    }, _react["default"].createElement(_PhoneModel["default"], {
      selectList: selectList
    }, this.renderSelcetList()), _react["default"].createElement("div", {
      className: "offer_content"
    }, this.renderOfferItemColums())));
  };

  return CapacityOffer;
}(_react.Component);

CapacityOffer.propTypes = {
  offerList: _propTypes["default"].array,
  selectList: _propTypes["default"].array,
  spinning: _propTypes["default"].bool,
  reset: _propTypes["default"].func,
  handAddOffer: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  openOfferDetail: _propTypes["default"].func
};
CapacityOffer.defaultProps = {
  offerList: [],
  selectList: [],
  spinning: false,
  reset: function reset() {
    return undefined;
  },
  handAddOffer: function handAddOffer() {
    return undefined;
  },
  onChange: function onChange() {
    return undefined;
  },
  openOfferDetail: function openOfferDetail() {
    return undefined;
  }
};
var _default = CapacityOffer;
exports["default"] = _default;